// SCTPClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SCTPClient.h"
#include "SCTPClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CBuffer buffer;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



extern CBuffer buffer;
/////////////////////////////////////////////////////////////////////////////
// CSCTPClientDlg dialog

CSCTPClientDlg::CSCTPClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSCTPClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSCTPClientDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSCTPClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSCTPClientDlg)
	DDX_Control(pDX, IDC_LIST1, m_list);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSCTPClientDlg, CDialog)
	//{{AFX_MSG_MAP(CSCTPClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON2, OnExit)
	ON_BN_CLICKED(IDC_BUTTON1, OnConnect_Server)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSCTPClientDlg message handlers

BOOL CSCTPClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here


	m_buffer = new unsigned char [22000];

	m_H263 = new H263Cont(this);
	m_H263->SetDisplayWindow(34, 30, 352, 288);

	m_H263->StartDecoder();

	m_IsAudio = false;

	m_audio_codec=NULL;
	m_audio_codec = new CAudioIO(this);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSCTPClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSCTPClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSCTPClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSCTPClientDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}


int receviesize=0;
int size=0,a;
int  AudioCnt=0;
void dataArriveNotif(unsigned int assocID, unsigned short streamID, unsigned int len,
                     unsigned short streamSN, unsigned int TSN, unsigned int protoID,
                     unsigned int unordered, void* ulpDataPtr)
{
    unsigned char chunk[SCTP_MAXIMUM_DATA_LENGTH + 1];
    unsigned int length;
    unsigned short ssn;
    unsigned int the_tsn;
 
    if (vverbose) {  
      fprintf(stdout, "%-8x: Data arrived (%u bytes on stream %u, %s)\n",
                      assocID, len, streamID, (unordered==SCTP_ORDERED_DELIVERY)?"ordered":"unordered");
      fflush(stdout);
    }
    /* read it */
        
 //   length = SCTP_MAXIMUM_DATA_LENGTH;
 //   clientsctp.SCTP_receive(assocID, streamID, chunk, &length, &ssn, &the_tsn, SCTP_MSG_DEFAULT);
 //   chunk[length] = 0;
   // fprintf(stdout, "%s", chunk);



	unsigned char * tempbuffer;
	tempbuffer=new unsigned char [22000];


//	int readsize=Receive(m_buffer, 30000 );
	unsigned int readsize;	
	unsigned int audio_readsize;

	clientsctp.SCTP_receive(assocID, streamID, tempbuffer, &readsize, &ssn, &the_tsn, SCTP_MSG_DEFAULT);
	

	
	
	if(streamID==3)
	{
		
			CString tempString;
	tempString.Format(" read data = %d",protoID);
	Maindlg->m_list.AddString( tempString ) ;

		   audio_readsize=readsize;
		   memcpy(((CSCTPClientDlg *)Maindlg)->m_audio_codec->rm_line,tempbuffer, audio_readsize);
		   AudioCnt = AudioCnt + audio_readsize;

		   if(AudioCnt >= LINE_LENG)
			{
			   ((CSCTPClientDlg *)Maindlg)->m_audio_codec->DecodingPlay();
			   AudioCnt = 0;
			}
			



	  
		  // AfxMessageBox("sdfsdf"); 
		delete [] tempbuffer;
	}
	else
	{

		int i;

		if(*(tempbuffer+2) == '*' && *(tempbuffer+3) == '*' && *(tempbuffer+4) == '*' &&
			*(tempbuffer+5) == '*' && *(tempbuffer+6) == '*' )
		
	//	if(receviesize>=size)
		{
	//		int size,i,a;
	//		receivesize = size = (*m_buffer * 256) + *(m_buffer + 1);
	//		a = *(m_buffer + 2);
			
			receviesize=0;
			size=0;

			size = (*tempbuffer * 256) + *(tempbuffer + 1);
			
			memcpy(Maindlg->m_buffer,tempbuffer,readsize);
		

		}
		else
		{
			memcpy((Maindlg->m_buffer+receviesize),tempbuffer,readsize);

		}


		receviesize=receviesize+readsize;


		delete [] tempbuffer;

		if(receviesize>=size)
		{
			for (i=7; i<size+7; i++)
			{
				buffer.PutData( *(Maindlg->m_buffer + i) );
			
			}
		}
		//receviesize=0;
		//size=0;
	   // fflush(stdout);

	}

	


}

void sendFailureNotif(unsigned int assocID,
                      unsigned char *unsent_data, unsigned int dataLength, unsigned int *context, void* dummy)
{
  if (verbose) {  
    fprintf(stdout, "%-8x: Send failure\n", assocID);
    fflush(stdout);
  }
}

void networkStatusChangeNotif(unsigned int assocID, short destAddrIndex, unsigned short newState, void* ulpDataPtr)
{
    SCTP_AssociationStatus assocStatus;
    SCTP_PathStatus pathStatus;
    unsigned short pathID;
    
    if (verbose) {  
        clientsctp.SCTP_getPathStatus(assocID, destAddrIndex, &pathStatus);
        fprintf(stdout, "%-8x: Network status change: path %u (towards %s) is now %s\n", 
                assocID, destAddrIndex, pathStatus.destinationAddress, pathStateName(newState));
        fflush(stdout);
    }
    
    /* if the primary path has become inactive */
    if ((newState == SCTP_PATH_UNREACHABLE) &&
        (destAddrIndex == clientsctp.SCTP_getPrimary(assocID))) {
        
        /* select a new one */ 
        clientsctp.SCTP_getAssocStatus(assocID, &assocStatus);
        for (pathID=0; pathID < assocStatus.numberOfAddresses; pathID++){
            clientsctp.SCTP_getPathStatus(assocID, pathID, &pathStatus);
            if (pathStatus.state == SCTP_PATH_OK)
                break;
        }
        
        /* and use it */
        if (pathID < assocStatus.numberOfAddresses) {
            clientsctp.SCTP_setPrimary(assocID, pathID);
        }
    }
}

void* communicationUpNotif(unsigned int assocID, int status,
                           unsigned int noOfDestinations,
                           unsigned short noOfInStreams, unsigned short noOfOutStreams,
                           int associationSupportsPRSCTP, void* dummy)
{   
    SCTP_PathStatus pathStatus;
    unsigned int i;
    
    if (verbose) {  
        fprintf(stdout, "%-8x: Communication up (%u paths, %u In-Streams, %u Out-Streams)\n", assocID, noOfDestinations, noOfInStreams, noOfOutStreams);
        fflush(stdout);
    }
    if (vverbose) {
        for (i=0; i < noOfDestinations; i++) {
            clientsctp.SCTP_getPathStatus(assocID, (unsigned short)i, &pathStatus);
            fprintf(stdout, "%-8x: Path Status of path %u (towards %s): %s.\n", assocID, i, pathStatus.destinationAddress, pathStateName(pathStatus.state));
            clientsctp.SCTP_changeHeartBeat(assocID, (short)i, 1, HBInterval);
        }
    }
    numberOutStreams = noOfOutStreams;
    return NULL;
}

void communicationLostNotif(unsigned int assocID, unsigned short status, void* ulpDataPtr)
{   
    unsigned char buffer[SCTP_MAXIMUM_DATA_LENGTH];
    unsigned int bufferLength;
    unsigned short streamID, streamSN;
    unsigned int protoID;
    unsigned int tsn;

    if (verbose) {
        fprintf(stdout, "%-8x: Communication lost (status %u)\n", assocID, status);
        fflush(stdout);
    }
    
    /* retrieve data */
    bufferLength = sizeof(buffer);
    while (clientsctp.SCTP_receiveUnsent(assocID, buffer, &bufferLength, &tsn, &streamID, &streamSN, &protoID) >= 0){
        if (vverbose) {
            fprintf(stdout, "%-8x: Unsent data (%u bytes) retrieved (TSN = %u, SID = %u, SSN = %u, PPI = %u): %s", 
                            assocID, bufferLength, tsn, streamID, streamSN, protoID, buffer);
            fflush(stdout);
        }
        bufferLength = sizeof(buffer);
    }
    
    bufferLength = sizeof(buffer);
    while (clientsctp.SCTP_receiveUnacked(assocID, buffer, &bufferLength, &tsn, &streamID, &streamSN, &protoID) >= 0){
        if (vverbose) {
            fprintf(stdout, "%-8x: Unacked data (%u bytes) retrieved (TSN = %u, SID = %u, SSN = %u, PPI = %u): %s", 
                            assocID, bufferLength, tsn, streamID, streamSN, protoID, buffer);
            fflush(stdout);
        }
        bufferLength = sizeof(buffer);
    }
                      
    /* delete the association, instace and terminate */
    clientsctp.SCTP_deleteAssociation(assocID);
    clientsctp.SCTP_unregisterInstance((unsigned short)video_sctpInstance);
    exit(0);
}

void communicationErrorNotif(unsigned int assocID, unsigned short status, void* dummy)
{
  if (verbose) {  
    fprintf(stdout, "%-8x: Communication error (status %u)\n", assocID, status);
    fflush(stdout);
  }
}

void restartNotif(unsigned int assocID, void* ulpDataPtr)
{    
    if (verbose) {  
        fprintf(stdout, "%-8x: Restart\n", assocID);
        fflush(stdout);
    }
}

void shutdownCompleteNotif(unsigned int assocID, void* ulpDataPtr)
{
    if (verbose) {  
        fprintf(stdout, "%-8x: Shutdown complete\n", assocID);
        fflush(stdout);
    }
    
    /* delete the association, instance and terminate */
    clientsctp.SCTP_deleteAssociation(assocID);
    clientsctp.SCTP_unregisterInstance((unsigned short)video_sctpInstance);
    exit(0); 
}

void shutdownReceivedNotif(unsigned int assocID, void* ulpDataPtr)
{
    if (verbose) {  
        fprintf(stdout, "%-8x: Shutdown received\n", assocID);
        fflush(stdout);
    }
}


char *
pathStateName(unsigned int state)
{
    switch (state) {
        case SCTP_PATH_OK:
            return "REACHABLE";
            break;
        case SCTP_PATH_UNREACHABLE:
            return "UNREACHABLE";
            break;
        case SCTP_PATH_ADDED:
            return "ADDED";
            break;
        case SCTP_PATH_REMOVED:
            return "REMOVED";
            break;
        case SCTP_PATH_CONFIRMED:
            return "CONFIRMED";
            break;
        case SCTP_PATH_UNCONFIRMED:
            return "UNCONFIRMED";
            break;
        default:
            return "UNKNOWN";
            break;
    }
}

int CSCTPClientDlg::StartSctpclient()
{


	   /* initialize the terminal_ulp variable */
    video_Ulp.dataArriveNotif           = &dataArriveNotif;
    video_Ulp.sendFailureNotif          = &sendFailureNotif;
    video_Ulp.networkStatusChangeNotif  = &networkStatusChangeNotif;
    video_Ulp.communicationUpNotif      = &communicationUpNotif;
    video_Ulp.communicationLostNotif    = &communicationLostNotif;
    video_Ulp.communicationErrorNotif   = &communicationErrorNotif;
    video_Ulp.restartNotif              = &restartNotif;
    video_Ulp.shutdownCompleteNotif     = &shutdownCompleteNotif;
    video_Ulp.peerShutdownReceivedNotif = &shutdownReceivedNotif;

    audio_Ulp.dataArriveNotif           = &dataArriveNotif;
    audio_Ulp.sendFailureNotif          = &sendFailureNotif;
    audio_Ulp.networkStatusChangeNotif  = &networkStatusChangeNotif;
    audio_Ulp.communicationUpNotif      = &communicationUpNotif;
    audio_Ulp.communicationLostNotif    = &communicationLostNotif;
    audio_Ulp.communicationErrorNotif   = &communicationErrorNotif;
    audio_Ulp.restartNotif              = &restartNotif;
    audio_Ulp.shutdownCompleteNotif     = &shutdownCompleteNotif;
    audio_Ulp.peerShutdownReceivedNotif = &shutdownReceivedNotif;
    /* handle all command line options */
 //   getArgs(argc, argv);
    checkArgs();
    
    clientsctp.SCTP_initLibrary();
    clientsctp.SCTP_getLibraryParameters(&params);
    params.sendOotbAborts    = sendOOTBAborts;
    params.supportPRSCTP     = 1;
    params.checksumAlgorithm = SCTP_CHECKSUM_ALGORITHM_CRC32C;
    clientsctp.SCTP_setLibraryParameters(&params);

    video_sctpInstance=clientsctp.SCTP_registerInstance(localPort,
                                       MAXIMUM_NUMBER_OF_IN_STREAMS,  MAXIMUM_NUMBER_OF_OUT_STREAMS,
                                       noOfLocalAddresses, localAddressList,
                                       video_Ulp);

	/*
    audio_sctpInstance=clientsctp.SCTP_registerInstance(localPort,
                                       MAXIMUM_NUMBER_OF_IN_STREAMS,  MAXIMUM_NUMBER_OF_OUT_STREAMS,
                                       noOfLocalAddresses, localAddressList,
                                       audio_Ulp);
	*/

    /* set the TOS byte */
    clientsctp.SCTP_getAssocDefaults((unsigned short)video_sctpInstance, &instanceParameters);
    instanceParameters.ipTos               = tosByte;
    instanceParameters.rtoMin              = rto_min;
    instanceParameters.rtoMax              = rto_max;
    instanceParameters.rtoInitial          = rto_min;
    if (myRwndSpecified)
      instanceParameters.myRwnd = myRwnd;
    clientsctp.SCTP_setAssocDefaults((unsigned short)video_sctpInstance, &instanceParameters);

    video_associationID=clientsctp.SCTP_associate((unsigned short)video_sctpInstance, MAXIMUM_NUMBER_OF_OUT_STREAMS, destinationAddress, remotePort, NULL);
//    audio_associationID=clientsctp.SCTP_associate((unsigned short)audio_sctpInstance, MAXIMUM_NUMBER_OF_OUT_STREAMS, destinationAddress, 8, NULL);
  

	AfxBeginThread( threadFunc , (LPVOID)this );

//	clientsctp.SCTP_eventLoop();
	
	return true;

}

void CSCTPClientDlg::checkArgs()
{

	   int abortProgram;
    int printUsageInfo;
    
    abortProgram = 0;
    printUsageInfo = 0;
    
    if (noOfLocalAddresses == 0) {
#ifdef HAVE_IPV6
        strcpy((char *)localAddressList[noOfLocalAddresses], "::0");
#else
        strcpy((char *)localAddressList[noOfLocalAddresses], "0.0.0.0");
#endif
        noOfLocalAddresses++;
    }
    if (hasDestinationAddress==1) {
        printf("Error:   An destination address must be specified.\n");
        abortProgram = 1;
        printUsageInfo = 1;
    }
    if (unknownCommand ==1) {
         printf("Error:   Unkown options in command.\n");
         printUsageInfo = 1;
    }
    
   
}


UINT threadFunc ( LPVOID p )
{
 
	 while (1){
        clientsctp.SCTP_eventLoop();
    }

	return TRUE ;
}

//DEL void CSCTPClientDlg::OnButton1() 
//DEL {
//DEL 	// TODO: Add your control notification handler code here
//DEL 	
//DEL 	StartSctpclient();
//DEL }

void CSCTPClientDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

BOOL CSCTPClientDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	
//	AfxMessageBox("Sdfsdf");
	clientsctp.SCTP_unregisterInstance(video_sctpInstance);

	delete VidCap;
//	delete m_socket;
	delete m_H263;
	if(m_audio_codec)
		delete m_audio_codec;



	PostMessage(WM_QUIT);
	return CDialog::DestroyWindow();
}


BOOL CSCTPClientDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	
		// TODO: Add your specialized code here and/or call the base class
	if( pMsg->message == WM_KEYDOWN )
	{		
		if( pMsg->wParam == VK_ESCAPE )
			return TRUE;

		if( pMsg->wParam == VK_RETURN )
		{
			return TRUE;
		}
	}	

	return CDialog::PreTranslateMessage(pMsg);
}

void CSCTPClientDlg::OnExit() 
{

	//	AfxMessageBox("Sdfsdf");
	clientsctp.SCTP_unregisterInstance(video_sctpInstance);

	delete VidCap;
//	delete m_socket;
	delete m_H263;
	if(m_audio_codec)
		delete m_audio_codec;

	

	// TODO: Add your control notification handler code here
	PostMessage(WM_QUIT);
}

void CSCTPClientDlg::OnConnect_Server() 
{
	// TODO: Add your control notification handler code here
	StartSctpclient();
}
