/******************************************************************************

	VidCap.h: interface for the CVidCap class.	2000. 1

******************************************************************************/

#ifndef _VIDCAP_H_
#define _VIDCAP_H_

#define WM_CAPTURE WM_USER + 100
 
class CVidCap
{
public:	
	CVidCap(CWnd *pParent);
	virtual ~CVidCap();

	BOOL InitVideoCap();
	void SetWindowSize(int x, int y, int dx, int dy);
	void DisConnectDriver();
public:
	int m_ImageX, m_ImageY;
	int m_BitCount;

	void GetVideoFormat();
	void SetVideoFormat();
	void SetVideoSource();
	bool SetVideoSize(int image_x,int image_y);

	HWND m_hWndC;
	HWND m_hpWnd;
};

extern CVidCap *VidCap;

#endif // _VIDCAP_H_
