/******************************************************************************

	H.263 Coder & Decoder header File
		
******************************************************************************/
 
#ifndef __H263Cont_H__
#define __H263Cont_H__

#include "stdafx.h"

#define WM_FINISH_CODER	 WM_USER+50

class CH263Dec;

class H263Cont
{
public:
	H263Cont(CWnd *pWnd);
	~H263Cont();
		
	void finishFrame();
//	void Code(int frame_num, unsigned char *image);
	void IntraCoding(int frame_num);
	void InterCoding(int frame_num);
	void CloseCoder();
	void initialCoder(HWND hWnd);
	
	void InitDecoder(CWnd *pParent);
	void PlayFrame();
	void CloseDecoder();
	void SetDisplayWindow(int x, int y, int dx, int dy);
	
	void StartDecoder();
//	void StartEncoder(unsigned char *image);//, H263Cont *pH263);
	void StartEncoder(unsigned char *image);//, H263Cont *pH263);
	
	unsigned char *MakeYUV(unsigned char *pimage, int sx, int sy);
private:
	CH263Dec *h263Dec;
	
};
#endif //  __H263Cont_H__
