/******************************************************************************
  
  Buffer.h: interface for the CBuffer class.

******************************************************************************/
 
#ifndef _BUFFER_H_
#define _BUFFER_H_

class CBuffer  
{
public:
	int m_BufferSize;
	int m_inputIndex;
	int m_outputIndex;
	unsigned char *m_Buffer;
	
public:
	int GetBufferSize();
	bool PutData(unsigned char data);
	bool GetData(unsigned char &data);
	bool SetBufferSize(int size);
	CBuffer();
	virtual ~CBuffer();
};

#endif // _BUFFER_H_
