// SCTPServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SCTPServer.h"
#include "SCTPServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers



	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSCTPServerDlg dialog

CSCTPServerDlg::CSCTPServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSCTPServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSCTPServerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSCTPServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSCTPServerDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSCTPServerDlg, CDialog)
	//{{AFX_MSG_MAP(CSCTPServerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	
	ON_MESSAGE(WM_CAPTURE,OnCapture)
	ON_MESSAGE(WM_FINISH_CODER,OnfinishFrame)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSCTPServerDlg message handlers

BOOL CSCTPServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	

	m_IsCapture = false;
	m_IsAudio = false;

	m_audio_codec=NULL;
	m_audio_codec = new CAudioIO(this);


	StartCamera();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSCTPServerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSCTPServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSCTPServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



int CSCTPServerDlg::StartSctp()
{




    /* initialize the echo_ulp variable */
    video_Ulp.dataArriveNotif              = &echoDataArriveNotif;
    video_Ulp.sendFailureNotif             = &sendFailureNotif;
    video_Ulp.networkStatusChangeNotif     = &networkStatusChangeNotif;
    video_Ulp.communicationUpNotif         = &echoCommunicationUpNotif;
    video_Ulp.communicationLostNotif       = &communicationLostNotif;
    video_Ulp.communicationErrorNotif      = &communicationErrorNotif;
    video_Ulp.restartNotif                 = &echoRestartNotif;
    video_Ulp.shutdownCompleteNotif        = &shutdownCompleteNotif;
    video_Ulp.queueStatusChangeNotif       = &queueStatusChangeNotif;
    video_Ulp.peerShutdownReceivedNotif    = &shutdownReceivedNotif;

	/*
	audio_Ulp.dataArriveNotif           = &audioDataArriveNotif;
    audio_Ulp.sendFailureNotif          = &sendFailureNotif;
    audio_Ulp.networkStatusChangeNotif  = &networkStatusChangeNotif;
    audio_Ulp.communicationUpNotif      = &audioCommunicationUpNotif;
    audio_Ulp.communicationLostNotif    = &communicationLostNotif;
    audio_Ulp.communicationErrorNotif   = &communicationErrorNotif;
    audio_Ulp.restartNotif              = &restartNotif;
    audio_Ulp.shutdownCompleteNotif     = &shutdownCompleteNotif;
    audio_Ulp.queueStatusChangeNotif    = &queueStatusChangeNotif;
    audio_Ulp.peerShutdownReceivedNotif = &shutdownReceivedNotif;

  */
    checkArgs();
    
    mysctp.SCTP_initLibrary();
    mysctp.SCTP_getLibraryParameters(&params);
    params.sendOotbAborts    = sendOOTBAborts;
    params.checksumAlgorithm = SCTP_CHECKSUM_ALGORITHM_CRC32C;
    mysctp.SCTP_setLibraryParameters(&params);

    /* set up the "server" */
    mysctp.SCTP_registerInstance(ECHO_PORT,
                          MAXIMUM_NUMBER_OF_IN_STREAMS, MAXIMUM_NUMBER_OF_OUT_STREAMS,
                          noOfLocalAddresses, localAddressList,
                          video_Ulp);

	/*
	mysctp.SCTP_registerInstance(8,
                          MAXIMUM_NUMBER_OF_IN_STREAMS, MAXIMUM_NUMBER_OF_OUT_STREAMS,
                          noOfLocalAddresses, localAddressList,
                          audio_Ulp);
  
	*/
	AfxBeginThread( threadFunc , (LPVOID)this );

//	 mysctp.SCTP_eventLoop();
 

	return true;
}


void echoDataArriveNotif(unsigned int assocID, unsigned short streamID, unsigned int len,
                         unsigned short streamSN, unsigned int TSN, unsigned int protoID, unsigned int unordered, void* ulpDataPtr)
{
    unsigned char chunk[MAXIMUM_PAYLOAD_LENGTH];
    unsigned int length;
    unsigned short ssn;
    unsigned int tsn;

    if (vverbose) {  
      fprintf(stdout, "%-8x: Data arrived (%u bytes on stream %u, %s)\n",
                      assocID, len, streamID, (unordered==SCTP_ORDERED_DELIVERY)?"ordered":"unordered");
      fflush(stdout);
    }
    /* read it */
    length = MAXIMUM_PAYLOAD_LENGTH;
    mysctp.SCTP_receive(assocID, streamID, chunk, &length, &ssn, &tsn, SCTP_MSG_DEFAULT);
    /* and send it */
 //   SCTP_send(assocID,
 //             (unsigned short)min(streamID, ((struct ulp_data *) ulpDataPtr)->maximumStreamID),
 //             chunk, length,
 //             protoID,
 //             SCTP_USE_PRIMARY, SCTP_NO_CONTEXT, timeToLive, unordered, SCTP_BUNDLING_DISABLED);
}

void audioDataArriveNotif(unsigned int assocID, unsigned short streamID, unsigned int len,
                         unsigned short streamSN, unsigned int TSN, unsigned int protoID, unsigned int unordered, void* ulpDataPtr)
{
    unsigned char chunk[MAXIMUM_PAYLOAD_LENGTH];
    unsigned int length;
    unsigned short ssn;
    unsigned int tsn;

    if (vverbose) {  
      fprintf(stdout, "%-8x: Data arrived (%u bytes on stream %u, %s)\n",
                      assocID, len, streamID, (unordered==SCTP_ORDERED_DELIVERY)?"ordered":"unordered");
      fflush(stdout);
    }
    /* read it */
    length = MAXIMUM_PAYLOAD_LENGTH;
    mysctp.SCTP_receive(assocID, streamID, chunk, &length, &ssn, &tsn, SCTP_MSG_DEFAULT);
    /* and send it */
 //   SCTP_send(assocID,
 //             (unsigned short)min(streamID, ((struct ulp_data *) ulpDataPtr)->maximumStreamID),
 //             chunk, length,
 //             protoID,
 //             SCTP_USE_PRIMARY, SCTP_NO_CONTEXT, timeToLive, unordered, SCTP_BUNDLING_DISABLED);
}


void networkStatusChangeNotif(unsigned int assocID, short affectedPathID, unsigned short newState, void* ulpDataPtr)
{
    SCTP_AssociationStatus assocStatus;
    SCTP_PathStatus pathStatus;
    unsigned short pathID;
    
    if (verbose) {
        mysctp.SCTP_getPathStatus(assocID, affectedPathID, &pathStatus);
        fprintf(stdout, "%-8x: Network status change: path %u (towards %s) is now %s\n", 
                        assocID, affectedPathID,
                        pathStatus.destinationAddress,
                        pathStateName(newState));
        fflush(stdout);
    }
    
    /* if the primary path has become inactive */
    if ((newState == SCTP_PATH_UNREACHABLE) &&
        (affectedPathID == mysctp.SCTP_getPrimary(assocID))) {
        
        /* select a new one */
        mysctp.SCTP_getAssocStatus(assocID, &assocStatus);
        for (pathID=0; pathID < assocStatus.numberOfAddresses; pathID++){
            mysctp.SCTP_getPathStatus(assocID, pathID, &pathStatus);
            if (pathStatus.state == SCTP_PATH_OK)
                break;
        }
        
        /* and use it */
        if (pathID < assocStatus.numberOfAddresses) {
            mysctp.SCTP_setPrimary(assocID, pathID);
        }
    }
}


void* echoCommunicationUpNotif(unsigned int assocID, int status,
                               unsigned int noOfPaths,
                               unsigned short noOfInStreams, unsigned short noOfOutStreams,
                               int associationSupportsPRSCTP, void* dummy)
{	
    struct ulp_data *ulpDataPtr;
    SCTP_PathStatus pathStatus;
    unsigned int i;

    if (verbose) {  
        fprintf(stdout, "%-8x: Communication up (%u paths)\n", assocID, noOfPaths);
        fflush(stdout);
    }
    
    if (vverbose) {
        for (i=0; i < noOfPaths; i++) {
            mysctp.SCTP_getPathStatus(assocID, (short)i, &pathStatus);
            fprintf(stdout, "%-8x: Path Status of path %u (towards %s): %s.\n", assocID, i, pathStatus.destinationAddress, pathStateName(pathStatus.state));
        }
    }
  
    ulpDataPtr                   = (struct ulp_data *)malloc(sizeof(struct ulp_data));
    ulpDataPtr->maximumStreamID  = noOfOutStreams - 1;
    ulpDataPtr->ShutdownReceived = 0;


//	------------------------------------------
	Maindlg->video_assocID=assocID;
	Maindlg->m_IsCapture=true;
//	------------------------------------------


	if(!(Maindlg->m_IsAudio))
	{
			
			Maindlg->m_audio_codec->StartRecording();
	        Maindlg->m_IsAudio  = true;
	}


    return((void *) ulpDataPtr);
}


void* audioCommunicationUpNotif(unsigned int assocID, int status,
                               unsigned int noOfPaths,
                               unsigned short noOfInStreams, unsigned short noOfOutStreams,
                               int associationSupportsPRSCTP, void* dummy)
{	
    struct ulp_data *ulpDataPtr;
    SCTP_PathStatus pathStatus;
    unsigned int i;

    if (verbose) {  
        fprintf(stdout, "%-8x: Communication up (%u paths)\n", assocID, noOfPaths);
        fflush(stdout);
    }
    
    if (vverbose) {
        for (i=0; i < noOfPaths; i++) {
            mysctp.SCTP_getPathStatus(assocID, (short)i, &pathStatus);
            fprintf(stdout, "%-8x: Path Status of path %u (towards %s): %s.\n", assocID, i, pathStatus.destinationAddress, pathStateName(pathStatus.state));
        }
    }
  
    ulpDataPtr                   = (struct ulp_data *)malloc(sizeof(struct ulp_data));
    ulpDataPtr->maximumStreamID  = noOfOutStreams - 1;
    ulpDataPtr->ShutdownReceived = 0;


	Maindlg->audio_assocID=assocID;
	if(!(Maindlg->m_IsAudio))
	{
			
			Maindlg->m_audio_codec->StartRecording();
	        Maindlg->m_IsAudio  = true;
	}

    return((void *) ulpDataPtr);
}

void sendFailureNotif(unsigned int assocID,
                      unsigned char *unsent_data, unsigned int dataLength, unsigned int *context, void* dummy)
{
  if (verbose) {  
    fprintf(stdout, "%-8x: Send failure\n", assocID);
    fflush(stdout);
  }
}




void communicationLostNotif(unsigned int assocID, unsigned short status, void* ulpDataPtr)
{	
    unsigned char buffer[SCTP_MAXIMUM_DATA_LENGTH];
    unsigned int bufferLength;
    unsigned short streamID, streamSN;
    unsigned int protoID;
    unsigned int tsn;

    if (verbose) {
        fprintf(stdout, "%-8x: Communication lost (status %u)\n", assocID, status);
        fflush(stdout);
    }
  
    /* retrieve data */
    bufferLength = sizeof(buffer);
    while (mysctp.SCTP_receiveUnsent(assocID, buffer, &bufferLength, &tsn,
                              &streamID, &streamSN, &protoID) >= 0){
        if (vverbose) {
            fprintf(stdout, "%-8x: Retrieved unsent chunk with %u bytes (SSN %u, SID %u)\n", assocID,bufferLength,streamSN,streamID );
            fflush(stdout);
        }
        /* do something with the retrieved data */
        /* after that, reset bufferLength */
        bufferLength = sizeof(buffer);
    }
    
    bufferLength = sizeof(buffer);
    while (mysctp.SCTP_receiveUnacked(assocID, buffer, &bufferLength, &tsn,
			       &streamID, &streamSN, &protoID) >= 0){
        /* do something with the retrieved data */
        if (vverbose) {
            fprintf(stdout, "%-8x: Retrieved unacked chunk with %u bytes (SSN %u, SID %u)\n", assocID,bufferLength,streamSN,streamID );
            fflush(stdout);
        }
        /* after that, reset bufferLength */
        bufferLength = sizeof(buffer);
    }
                          
    /* delete the association */
    if (ulpDataPtr)
        free((struct ulp_data *) ulpDataPtr);
        
    mysctp.SCTP_deleteAssociation(assocID);
}

void communicationErrorNotif(unsigned int assocID, unsigned short status, void* dummy)
{
  if (verbose) {  
    fprintf(stdout, "%-8x: Communication error (status %u)\n", assocID, status);
    fflush(stdout);
  }
}



void echoRestartNotif(unsigned int assocID, void* ulpDataPtr)
{
    SCTP_AssociationStatus assocStatus;
    
    if (verbose) {  
        fprintf(stdout, "%-8x: Restart\n", assocID);
        fflush(stdout);
    }
    
    mysctp.SCTP_getAssocStatus(assocID, &assocStatus);
    
    /* update ULP data */
    ((struct ulp_data *) ulpDataPtr)->maximumStreamID = assocStatus.outStreams - 1;
}

void restartNotif(unsigned int assocID, void* ulpDataPtr)
{    
    if (verbose) {  
        fprintf(stdout, "%-8x: Restart\n", assocID);
        fflush(stdout);
    }
}

void shutdownCompleteNotif(unsigned int assocID, void* ulpDataPtr)
{
  if (verbose) {  
    fprintf(stdout, "%-8x: Shutdown complete\n", assocID);
    fflush(stdout);
  }
  if (ulpDataPtr)
    free((struct ulp_data *) ulpDataPtr);
    
  mysctp.SCTP_deleteAssociation(assocID);
}

void queueStatusChangeNotif(unsigned int assocID, int queueType, int queueID, int queueLength, void* ulpDataPtr)
{	
    if (vverbose) {
        fprintf(stdout, "%-8x: Queue status change notification: Type %d, ID %d, Length %d\n",
                        assocID, queueType, queueID, queueLength);
        fflush(stdout);
    }
}



void shutdownReceivedNotif(unsigned int assocID, void* ulpDataPtr)
{
    if (verbose) {  
        fprintf(stdout, "%-8x: Shutdown received\n", assocID);
        fflush(stdout);
    }
    if (ulpDataPtr)
        ((struct ulp_data *)ulpDataPtr)->ShutdownReceived = 1;
}

void CSCTPServerDlg::checkArgs()
{

	int abortProgram;
    int printUsageInfo;
    
    abortProgram = 0;
    printUsageInfo = 0;
    
    if (noOfLocalAddresses == 0) {
#ifdef HAVE_IPV6
        strcpy((char *)localAddressList[noOfLocalAddresses], "::0");
#else
        strcpy((char *)localAddressList[noOfLocalAddresses], "0.0.0.0");
#endif
        noOfLocalAddresses++;
    }

}


char *
pathStateName(unsigned int state)
{
    switch (state) {
        case SCTP_PATH_OK:
            return "REACHABLE";
            break;
        case SCTP_PATH_UNREACHABLE:
            return "UNREACHABLE";
            break;
        case SCTP_PATH_ADDED:
            return "ADDED";
            break;
        case SCTP_PATH_REMOVED:
            return "REMOVED";
            break;
        case SCTP_PATH_CONFIRMED:
            return "CONFIRMED";
            break;
        case SCTP_PATH_UNCONFIRMED:
            return "UNCONFIRMED";
            break;
        default:
            return "UNKNOWN";
            break;
    }
}


UINT threadFunc ( LPVOID p )
{
 	

	while (1) {
        mysctp.SCTP_eventLoop();
    }
	return TRUE ;
}

void CSCTPServerDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	StartSctp();
}

int CSCTPServerDlg::StartCamera()
{
			// Initial Code.......

	m_H263 = new H263Cont(this);
	m_H263->SetDisplayWindow(270, 30, 176, 144);


	m_H263->StartDecoder();

	m_IsCapture = false;


	VidCap = new CVidCap(this);
	VidCap->SetWindowSize(34,30,176,144);

	if(VidCap->InitVideoCap())
	{
		VidCap->GetVideoFormat();
		if((VidCap->m_ImageX != 176) || (VidCap->m_ImageY != 144))
		{
			VidCap->SetVideoSize(176,144);
			if(VidCap)
			{
				VidCap->DisConnectDriver();
				delete VidCap;
				VidCap=NULL;
			}
			VidCap = new CVidCap(this);
			VidCap->SetWindowSize(34,30,176,144);
			VidCap->InitVideoCap();	
		}
	}

	return true;
}

void CSCTPServerDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CSCTPServerDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}


//-----------------------------------------------------------------------------
bool isEncode = true;

void CSCTPServerDlg::OnCapture(WPARAM wParam, LPARAM lParam)
{
	CString str;
	
	if (m_IsCapture) 
	{

		if (isEncode)
		{
			isEncode = false;


			if(VidCap->m_BitCount == 24)
			{
				
				m_H263->StartEncoder(m_H263->MakeYUV((unsigned char *) wParam,176,144));

			}
			else
				m_H263->StartEncoder((unsigned char*) wParam);
		}
	}
}
//-----------------------------------------------------------------------------
void CSCTPServerDlg::OnfinishFrame(WPARAM wParam, LPARAM lParam)
{
	int size = (int)lParam;
	unsigned char *data = (unsigned char *)wParam;


	int roop=0;
	int Buff_size;
	unsigned char *Buff;
	unsigned char *temp_Buff;
	Buff = new unsigned char [size+9];
	
	Buff_size=size+9;

	*Buff = size / 256;
	*(Buff+1) = size % 256;

	*(Buff+2) = '*';	
	*(Buff+3) = '*';	
	*(Buff+4) = '*';		
	*(Buff+5) = '*';		
	*(Buff+6) = '*';	

	memcpy(Buff+7,data,size);

//	m_socket->SendTo(Buff ,size+4, m_socket->nPort, m_socket->Ip);

//	if(m_videoclientsocket)
//		m_videoclientsocket->Send(Buff ,size+9);
	temp_Buff=Buff;
	roop=Buff_size/1400;



	for(int i=0;i<=roop;i++)
	{
		if(i==roop)
		{
	
		   mysctp.SCTP_send(Maindlg->video_assocID,
					 0,
					 Buff, Buff_size%1400,
					 132,
					  SCTP_USE_PRIMARY, SCTP_NO_CONTEXT, 10, 1, SCTP_BUNDLING_DISABLED);
		
		  
			Buff=temp_Buff;

//AfxMessageBox(" ");
		   break ;
		}
		else
		{
				   mysctp.SCTP_send(Maindlg->video_assocID,
				 0,
				 Buff, 1400,
				 132,
				  SCTP_USE_PRIMARY, SCTP_NO_CONTEXT, 10, 1, SCTP_BUNDLING_DISABLED);
	

				   Buff=Buff+1400;
				  // AfxMessageBox("sdsd");
		}
	}

	delete [] Buff;

	isEncode = true;
	
}
//-----------------------------------------------------------------------------


